/*

GTKMMBINDINGS

  THIS MODULE PROVIDES AN INTERFACE FOR VISUALISATION OF OPTIC 
  FLOW, SALIENCY MAPS OR IMAGES BY MAKING USE OF GTK.

COPYRIGHT (C)

  ULM UNIVERSITY 
  INSTITUTE OF NEURAL INFORMATION PROCESSING (NEUROINFORMATIK)
  89069 ULM
  GERMANY

CONTACT INFORMATION AVAILABLE AT:

  INSTITUTE OF NEURAL INFORMATION PROCESSING:
  http://www.uni-ulm.de/en/in/institute-of-neural-information-processing.html

  ULM UNIVERSITY 
  HTTP://WWW.UNI-ULM.DE/

This software is governed by the CeCILL-C license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the 
CeCILL-C license as circulated by CEA, CNRS and INRIA at the following 
URL "http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL-C license and that you accept its terms.

*/

/*
 * Window.cpp
 *
 *  Created on: Sep 30, 2008
 *      Author: jbouecke
 */

#include "Window.h"
#ifdef HAVE_GLUT
#include <GL/glut.h>
#endif

#include <iostream>

Window::Window() {
}

Window::~Window() {
	;
}

bool Window::global_gtk_gl_initated = false;

void Window::global_gtk_gl_init(int &argc, char** &argv) 
{
  if (!global_gtk_gl_initated) 
	{
	new Gtk::Main(argc, argv);
	Gtk::GL::init(argc, argv);
	Glib::thread_init();
#ifdef HAVE_GLUT
    glutInit( &argc, argv );
#endif
	global_gtk_gl_initated = true;
  }
}
void Window::global_gtk_gl_init() {
	if (!global_gtk_gl_initated) {
		int argc = 0;
		char** argv = 0;
		global_gtk_gl_init(argc,argv);
	}
}

bool Window::process_gtk_events(bool blocking) {
	return Gtk::Main::iteration(blocking);
}

void Window::process_all_pending_gtk_events() {
	while (Gtk::Main::events_pending())
		Gtk::Main::iteration(false);
}

void Window::wait_until_closed() 
{
	while (Gtk::Main::events_pending())
		process_gtk_events(false);
	process_gtk_events(false);
	closed = false;
	while (!closed) {
		process_gtk_events(true);
	}

}

void Window::busy_wait(int milli_sec) {
//	static Glib::Cond  condition;
//	static Glib::Mutex mutex;
//	Glib::TimeVal time;
//	time.add_milliseconds(milli_sec);
//	mutex.lock();
//	condition.timed_wait(mutex,time);
//	mutex.unlock();
	clock_t start = clock();
	;;
	clock_t current = clock();
	while (double(current - start)/CLOCKS_PER_SEC < milli_sec/1000.0) {
		for (int i=0; i<10; ++i) {
			process_gtk_events(false);
		}
		current = clock();
	}

}
