/*

GTKMMBINDINGS

  THIS MODULE PROVIDES AN INTERFACE FOR VISUALISATION OF OPTIC 
  FLOW, SALIENCY MAPS OR IMAGES BY MAKING USE OF GTK.

COPYRIGHT (C)

  ULM UNIVERSITY 
  INSTITUTE OF NEURAL INFORMATION PROCESSING (NEUROINFORMATIK)
  89069 ULM
  GERMANY

CONTACT INFORMATION AVAILABLE AT:

  INSTITUTE OF NEURAL INFORMATION PROCESSING:
  http://www.uni-ulm.de/en/in/institute-of-neural-information-processing.html

  ULM UNIVERSITY 
  HTTP://WWW.UNI-ULM.DE/

This software is governed by the CeCILL-C license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the 
CeCILL-C license as circulated by CEA, CNRS and INRIA at the following 
URL "http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL-C license and that you accept its terms.

*/
/*
 * Window.h
 *
 *  Created on: Sep 30, 2008
 *      Author: jbouecke
 */

#ifndef WINDOW_H_
#define WINDOW_H_

#define GL_GLEXT_PROTOTYPES
#include <gtkmm.h>
#include <gtkglmm.h>
#include <gtkmm/gl/drawingarea.h>

class Window : public Gtk::Window {
	/* begin static part */
public:
	static void global_gtk_gl_init(int &argc, char** &argv);
	static void global_gtk_gl_init();
	static bool process_gtk_events(bool blocking=false);
	static void process_all_pending_gtk_events();
	static void busy_wait(int milli_sec);
private:
	static bool global_gtk_gl_initated;
	/* end static part */

public:
	Window();
	virtual ~Window();
	virtual void repaint(bool directly=true) = 0;
	void wait_until_closed();

protected:
	bool closed;

};

#endif /* WINDOW_H_ */
