/*

MATH

  THIS MODULE INCLUDES GENERIC MATH UTILITIES

COPYRIGHT (C)

  FRAUNHOFER FIT-LIFE
  SCHLOSS BIRLINGHOVEN
  53754 ST. AUGUSTIN
  GERMANY

CONTACT INFORMATION AVAILABLE AT:

  Fraunhofer-Institut für Angewandte Informationstechnik FIT 
  http://fit.fraunhofer.de

This software is governed by the CeCILL-C license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the 
CeCILL-C license as circulated by CEA, CNRS and INRIA at the following 
URL "http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL-C license and that you accept its terms.

*/
#pragma once
#include <vector>
#include <algorithm>

// from numerical recipes
template<class T>
T kth_largest(const int k, std::vector<T> & arr, size_t n )
{
  int i,ir,j,l,mid;
  T a;
  l=0;
  ir=n-1;
  for (;;) 
	{
	  if (ir <= l+1) 
		{
		  if (ir == l+1 && arr[ir] < arr[l])
			std::swap(arr[l],arr[ir]);
		  return arr[k];
		} 
	  else 
		{
		  mid=(l+ir) >> 1;
		  std::swap(arr[mid],arr[l+1]);
		  if (arr[l] > arr[ir])
			std::swap(arr[l],arr[ir]);
		  if (arr[l+1] > arr[ir])
			std::swap(arr[l+1],arr[ir]);
		  if (arr[l] > arr[l+1])
			std::swap(arr[l],arr[l+1]);
		  i=l+1;
		  j=ir;
		  a=arr[l+1];
		  for (;;) 
			{
			  do i++; while (arr[i] < a);
			  do j--; while (arr[j] > a);
			  if (j < i) break;
			  std::swap(arr[i],arr[j]);
			}
		  arr[l+1]=arr[j];
		  arr[j]=a;
		  if (j >= k) ir=j-1;
		  if (j <= k) l=i;
		}
	}
}
