/*
Copyright INRIA 2011

Authors: Neil D.B. Bruce <Neil.Bruce@inria.fr>
Contact: Pierre Kornprobst <Pierre.Kornprobst@inria.fr>

This software is a computer program whose purpose is to estimate saliency.

This software is governed by the CeCILL-C license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL-C
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL-C license and that you accept its terms.
*/

#include <HDF5FloatFile.h>
#include <HDF5MotionFile.h>
#include <iostream>
#include <CPUData.hpp>
#include <Surprise.h>
#include <GPUData.h>
#include <DataWindow.hpp>

// Allow filename and channel to be given on the command line
// What are some better visualization options? - i.e. for more stability etc.

int main(int argc, char* argv[])
{
	
                int imnum=1;

                if (argc < 3)
                {
                std::cout << "\n" << " Usage: surpriseTestFull h5filename.h5 h5channel [bins] [type] [limitscale]" << "\n"; // 0 basic // 1 accumulating // 2 weighted // 3 buffered // 4 decaying // 5 pre-learned
                exit(1);
                }

                std::cout << argc << "\n";
                int bins=20;
                int type=0;
                float limitscale = 1.0;

                if (argc >= 4)
                {
                bins=atoi(argv[3]);
                }
                
                if (argc >= 5)
                {
                type=atoi(argv[4]);
                }
               
                if (argc >= 6)
                {
                limitscale=atof(argv[5]);
                }







               

                //HDF5FloatFile file("runnernew.h5");
		//HDF5FloatFile file("outnew.h5");
                //  HDF5FloatFile file("fight.h5");
                  HDF5FloatFile file(argv[1]);
               //   size_t* dims = file.getDataSizes("mt_normed");
		//size_t* dims = file.getDataSizes("mt");
                  size_t* dims = file.getDataSizes(argv[2]);
		//size_t* dims = file.getDataSizes("mt");

		int f = dims[3];
		int w = dims[2];
		int h = dims[1];
		int n = dims[0];
                //n=5; % process a fixed number of frames
		size_t dims_slice[4] = {1,h,w,f};
		size_t offs_slice[4] = {0,0,0,0};
                int sw = 0;
                CPUData<float> testMatrix(2*sw+1,2*sw+1,1);
                //std::cout << testMatrix.dump_dims() << std::endl;
		testMatrix = (1.0/((2*sw+1)*(2*sw+1)));
                
                //testMatrix(sw,sw,1) = 1.0;
                //testMatrix.normalize();

		//Surprise surpriseO(h,w,f,bins,type);
                Surprise surpriseO(h,w,f,bins,type,0.2,0.02,sw,limitscale,testMatrix);
                //surpriseO.setScaleType(1);
                Surprise surprise1(h,w, f,bins,1,0,0,sw,2.0);
                // Reading in a set of limits for range - *************** USEFUL EXAMPLE
                
                // Useful test things!
                //surpriseO.readRange("testrange.txt");
                //surpriseO.readPriorDensities("testdensities.h5");
                //surprise1.readRange("testrange.txt");
                //surprise1.readPriorDensities("testdensities.h5");
		//printf("%d %d %d %d\n",n,h,w,f);

                float* thevel = new float[w*h*f];
                
                 // Which slice?!?
		
                //file.readDataSet(data,offs_slice,dims_slice);


               // HDF5MotionFile file("taxi.h5");
		DataWindow* sliceWindow     = 0;
                DataWindow* imageWindow     = 0;
                imageWindow->global_gtk_gl_init();
                //imageWindow->setSaturateEntropy(false);
		imageWindow  = new DataWindow(w,h,"The Image");
                sliceWindow->global_gtk_gl_init();
		sliceWindow  = new DataWindow(w,h,"Surprise Surprise");
         


                for (imnum=0;imnum<n;imnum++) {
               	//sprintf(v1_frame_name,"V1_%05d",imnum);
                offs_slice[0] = imnum;
                //sprintf(v1_frame_name,"input_image_%05d",imnum);
		//sprintf(v1_frame_name,"MT_%05d",imnum);
		
                file.readDataSet(thevel,offs_slice,dims_slice);
                //int* dims = file.getDataSizes(v1_frame_name);
                //numvels=file.getNoOfVelocities(v1_frame_name);
		
                //int h=dims[0];
                //int w=dims[1];

                //printf("%d %d %d\n",w,h,numvels);


		//Velocity* velField = new Velocity[numvels];
		//file.getVelocitySpace(velField,v1_frame_name); - there is no velocity space stored
                

               //float* thevel = new float[w*h*numvels];
               //file.readDataSet(thevel);


                //printf("%0.32f\n",thevel[10000]);
		
                CPUData<float> velData = CPUData<float>(thevel,h,w,f);

                //printf("%0.32f\n",velData(10,10,10));


               
                   
                //printf("HEY !! %d %d %d !!\n",h,w,f); 


		GPUData featSlices = GPUData(h,w,f);
                featSlices.copyFrom(velData);
                GPUData oneSlice = featSlices.slice(2,5);
                oneSlice.makeContiguous(true);

                


               // Do surprise stuff
               surpriseO.setCurrentData(velData);
               surprise1.setCurrentData(velData);
               CPUData<float> surpriseResult = surpriseO.returnCombinedSurprise();
               CPUData<float> surpriseResult2 = surprise1.returnCombinedSurprise(); //surprise1.discriminantSaliency(surpriseO.returnNormedDensities());
               //surpriseResult(0,0) = 0.0;  
               //surpriseResult(h-1,w-1) = 70.0;  

	       GPUImage surpriseGPU = GPUData(h,w);
               surpriseGPU.copyFrom(surpriseResult);

               GPUImage surpriseGPU2 = GPUData(h,w);
               surpriseGPU2.copyFrom(surpriseResult2);
               //GPUData surpSlice = surpriseGPU.slice(2,1);
               //surpSlice.makeContiguous();
	       //GPUImage surpriseGPUIm(w,h);
              






		//imageWindow->update(oneSlice,oneSlice);
		sliceWindow->update(surpriseGPU);
                imageWindow->update(surpriseGPU2);
                //imageWindow->update(featSlices);
                //sleep(2);
                
                }
		//GPUImage animage(w,h);
		//sliceWindow->global_gtk_gl_init();
                //sliceWindow->update(animage,oneSlice);
                
                // ******************* USEFUL EXAMPLE
		//surpriseO.writeRange("testrange.txt");
                //surpriseO.writePriorDensities("testdensities.h5");


                //sleep(100);
                //if (sliceWindow) delete sliceWindow;
                

                
                //surpriseO.
                //gtk_main();
                //gtk_main(); */


}
