#include "memblock_manager_singleton_tls.hpp"

namespace blitz
{

  void delete_manager_if_empty_else_detach( struct memblock_manager * manager )
  {
	if ( manager->alive() )
	  manager->detach();
	else
	  delete manager;
  }

  // todo: if another thread still holds data from this manager then we cannot delete it upon thread exit
  // instead it mus be kept alive and the last deleter must delete it instead
  // and all this in a thread safe manner
  boost::thread_specific_ptr< struct memblock_manager > memblock_manager( delete_manager_if_empty_else_detach );
  //boost::thread_specific_ptr< struct memblock_manager > memblock_manager;

}; // ns blitz
