#ifndef __OMP_MACROS_FUNCTIONS_HPP
#define __OMP_MACROS_FUNCTIONS_HPP

#include <blitz/range.h>
#include <iostream>

inline void omp_log( const std::string & message )
{
#pragma omp critical
  {
	for ( int i = 0; i < omp_get_thread_num(); ++i )
	  std::cout << "                        ";
	std::cout << message << std::endl;
  }
}

inline blitz::Range make_work_range( int n )
{
  if ( omp_in_parallel() )
	{
	  int N = omp_get_num_threads();
	  int delta = ( n + N - 1 ) / N;
	  int id = omp_get_thread_num();
	  int first = delta * id;
	  int last = std::min( n, delta * ( id + 1 ) ) - 1;
	  return blitz::Range( first, last );
	}
  else
	return blitz::Range( 0, n - 1 );
}


#endif
